/*
 * DefaultGame.h
 *
 *  Created on: 22 Jun 2013
 *      Author: Ashley
 */

#ifndef DEFAULTGAME_H_
#define DEFAULTGAME_H_

#include "ARK.h"

#include "states/BlankState.h"
#include "states/MyLoadingState.h"
#include "states/SplashState.h"
#include "states/MenuState.h"
#include "states/InstructionsState.h"
#include "states/InGameState.h" 
#include "states/SummaryState.h" 

#include "objects/Backdrop.h" 


class StatesList {
	public:

		static const unsigned int STATE_BLANK = 0;
		static const unsigned int STATE_LOADING = 1;
		static const unsigned int STATE_SPLASH = 2;
		static const unsigned int STATE_MENU = 3;
		static const unsigned int STATE_INSTRUCTIONS = 4;
		static const unsigned int STATE_INGAME = 5;
		static const unsigned int STATE_SUMMARY = 6; 
};

class DefaultGame : public StateBasedGame {
	public:

		BlankState* stateBlank;
		MyLoadingState* stateLoading;
		SplashState* stateSplash; 
		MenuState* stateMenu;  
		InstructionsState* stateInstructions;
		InGameState* stateInGame;
		SummaryState* stateSummary;  

		Image* spritesheet;
		SpriteSheetDescription* desc;

		ARK::Font::BMFont* font;
		Backdrop* backdrop;

		Image* m_buttonLeft;
		Image* m_buttonTile;
		Image* m_buttonRight;

		Sound* m_music;

		Sound* m_sfxGlass;
		Sound* m_sfxMenuConfirm;
		Sound* m_sfxMenuBack;
		Sound* m_sfxMenuSwitch;
		Sound* m_sfxDie;

		DefaultGame(string title);
		void drawButton(int x, int y, int width);
		virtual void initStates(GameContainer* container);
		virtual void load();
		virtual void update(GameContainer* container, GameTimer* timer);
		virtual void render(GameContainer* container, Renderer* r);
		virtual void resize(GameContainer* container, int width, int height);
		virtual ~DefaultGame();

		static DefaultGame* getInstance();
};

#endif /* DEFAULTGAME_H_ */
