/*
 * Object.h
 * 18 April 2012
 */

#ifndef BACKDROP_H_
#define BACKDROP_H_

#include "../ARK.h"

class DefaultGame;

struct BackdropStar {
	unsigned int type;
	float x;
	float y;
	float rot;
	float diff;
	float speed;
};
void BackdropStar_set(BackdropStar* star);
Image* BackdropStar_getImage(BackdropStar* star);
float BackdropStar_getImageAlpha(BackdropStar* star);
float BackdropStar_getDiff(unsigned int t);
float BackdropStar_getSpeed(unsigned int t);

class Backdrop {
	public:
		unsigned int m_index;
		vector<Image*> m_gradients;
		vector<Color*> m_tints;
		vector<Color*> m_tints50a;
		Image* m_star1;
		Image* m_star2;
		Image* m_star3;

		vector<BackdropStar* >* m_stars;

		Color* getTint();
		Color* getTint50a();
		void next();
		
		Backdrop();
		void init();
		void update(GameContainer* container, GameTimer* timer);
		void render(GameContainer* container, Renderer* r);

		virtual ~Backdrop();
};

#endif /* BACKDROP_H_ */
