/*
 * Particle.cpp
 *
 *  Created on: 29 Jan 2011
 *      Author: Ashley
 */

#include "Particle.h"
#include "../DefaultGame.h"
  
#include "Player.h"
#include "Explosion.h"

//namespace Game { 

	Image* MyParticle::s_playerGib = NULL;

	MyParticle::MyParticle(): 
		Object()
		{

		DefaultGame* dg = DefaultGame::getInstance(); 

		m_bounds = new ARK::Geometry::Rectangle<float>(0, 0, 1, 1);
		m_bounds->setLocationByCenter(240, -50);
	 
		m_velocity->set(0, 0);  
		m_velocityMax->set(800, 800);    
		m_acceleration->set(0, 0); 

		if (s_playerGib == NULL) {
			s_playerGib = dg->spritesheet->getSubImage(dg->desc->getItemByName("player-gib.png"))->scale(2.0, 2.0f);
			s_playerGib->setCenterOfRotation(s_playerGib->getWidth()/2, s_playerGib->getHeight()/2);
		}
	 
	}   

	    
	void MyParticle::reset() {   
		m_velocity->set(0, 0);
	}  
	void MyParticle::start(unsigned int type) {
		InGameState* igs = DefaultGame::getInstance()->stateInGame;

		m_type = type;

		if (type == TYPE_PLAYER_GIB) {
			Player* p = igs->m_player;
			
			float distance = MathUtil::distance(0, 0, p->m_velocity->getX(), p->m_velocity->getY());
			float angle = MathUtil::anglef(0, 0, p->m_velocity->getX(), p->m_velocity->getY());
			float newAngle = angle - 20 + MathUtil::randBetweenf(0.0f, 40.0f);
			MathUtil::moveAngle<float>(m_velocity, newAngle, distance * MathUtil::randBetweenf(0.75f, 1.25f));

			m_alphaFadeTimer = 0.0f;
			m_alphaFadeDuration = 1.0f; 

		}
	}

	void MyParticle::update(GameContainer* container, GameTimer* timer) {

		InGameState* igs = DefaultGame::getInstance()->stateInGame;
		if (m_type == TYPE_PLAYER_GIB) {
			move(1.0f);
			m_alpha = Easing::ease(Easing::LINEAR, m_alphaFadeTimer, 1.0f, -1.0f, m_alphaFadeDuration);
			m_alphaFadeTimer += timer->getDelta() * igs->m_gameSpeed;
			if (m_alphaFadeTimer >= m_alphaFadeDuration) {
				setPendingRemoval(true);
			}
			gravity();
		}
	}

	void MyParticle::collision(Object* other) { 
		DefaultGame* dg = DefaultGame::getInstance();
		InGameState* igs = dg->stateInGame;

		Player* p = NULL;
		p = dynamic_cast<Player*>(other);
		if (p) {

		}  
	} 

	void MyParticle::render(GameContainer* container, Renderer* r) 
	{
		if (m_type == TYPE_PLAYER_GIB) {
			s_playerGib->setColor(DefaultGame::getInstance()->backdrop->getTint());
			s_playerGib->setAlpha(m_alpha);
			s_playerGib->drawCentered(m_bounds->getCenterX(), m_bounds->getCenterY());
		}
	}

	MyParticle::~MyParticle() { 
		 
	}

//}

