/*
 * MenuState.h
 * 08 Jun 2011
 */

#ifndef MENUSTATE_H_
#define MENUSTATE_H_

#include "../ARK.h"

class DefaultGame;

class MenuState : public GameState {
	public:
		signed int m_selectedIndex;

		static const int MENU_BEGIN = 0;
		static const int MENU_PLAY = 0;
		static const int MENU_INSTRUCTIONS = 1; 
		static const int MENU_EXIT = 2;
		static const int MENU_END = MENU_EXIT;

		Image* player;

		float m_introTimer;
		float m_introDuration;

		float m_outroTimer;
		float m_outroDuration;

		MenuState();
		void enter(GameContainer* container, StateBasedGame* game, GameState* from);
		void leave(GameContainer* container, StateBasedGame* game, GameState* to);

		unsigned int id();
		void init(GameContainer* container, StateBasedGame* game);
		void update(GameContainer* container, StateBasedGame* game, GameTimer* timer);
		void render(GameContainer* container, StateBasedGame* game, Renderer* r);

		virtual ~MenuState();
};

#endif /* MENUSTATE_H_ */
