/*
 * MyLoadingState.cpp
 *
 *  Created on: 29th Mar 2011
 *      Author: Ashley
 */

#include "../ARK.h"
#include "../DefaultGame.h"
#include "MyLoadingState.h"

MyLoadingState::MyLoadingState(DefaultGame* game):
	LoadingState(),
	m_game(game),
	m_firstFrame(true),
	m_nextState(NULL),
	m_textState(TEXTSTATE_OUT),
	m_showTextTimer(NULL), 
	m_hideTextTimer(NULL),
	m_overallTimer(NULL),
	m_doneLoading(false),
	m_loadItems()
{ 
	m_loading = true;

}

unsigned int MyLoadingState::id() {
	return StatesList::STATE_LOADING;
}

void MyLoadingState::enter(GameContainer* container, StateBasedGame* game, GameState* from) {

	m_doneLoading = false;
}
 
void MyLoadingState::leave(GameContainer* container, StateBasedGame* game, GameState* to) {

}

void loadItem1() {
	DefaultGame* dg = DefaultGame::getInstance();
	dg->spritesheet = Resource::get("sheet.png")->asImage();
	dg->desc = Resource::get("sheet.spritesheetdescription")->asSpriteSheetDescription();

	dg->backdrop->init();

	dg->m_buttonLeft = dg->spritesheet->getSubImage(dg->desc->getItemByName("button-left.png"));
	dg->m_buttonTile = dg->spritesheet->getSubImage(dg->desc->getItemByName("button-tile.png"));
	dg->m_buttonRight = dg->spritesheet->getSubImage(dg->desc->getItemByName("button-right.png"));

	dg->m_buttonLeft->setCenterOfRotation(dg->m_buttonLeft->getWidth()/2, dg->m_buttonLeft->getHeight()/2);
	dg->m_buttonTile->setCenterOfRotation(dg->m_buttonTile->getWidth()/2, dg->m_buttonTile->getHeight()/2);
	dg->m_buttonRight->setCenterOfRotation(dg->m_buttonRight->getWidth()/2, dg->m_buttonRight->getHeight()/2);

	dg->stateLoading->m_itemsAt++;
}
void loadItem2() {
	DefaultGame* dg = DefaultGame::getInstance();
	dg->m_music = Resource::get("music.ogg")->asSound();
	dg->stateLoading->m_itemsAt++;
}
void loadItem3() {
	DefaultGame* dg = DefaultGame::getInstance();
	
	dg->m_sfxGlass = Resource::get("sfx/glass.ogg")->asSound();
	dg->m_sfxDie = Resource::get("sfx/die.ogg")->asSound();
	dg->m_sfxMenuConfirm = Resource::get("sfx/menu-confirm.ogg")->asSound();
	dg->m_sfxMenuBack = Resource::get("sfx/menu-back.ogg")->asSound();
	dg->m_sfxMenuSwitch = Resource::get("sfx/menu-switch.ogg")->asSound();

	dg->stateLoading->m_itemsAt++;
}
void loadItem10() {
	DefaultGame* dg = DefaultGame::getInstance();
	dg->stateLoading->getThread()->start();
	dg->stateLoading->m_itemsAt++;
	
}

void MyLoadingState::init(GameContainer* container, StateBasedGame* game) {
	// override.
	m_firstFrame = true;

	m_showTextTimer = new Timer(0.6f);
	m_hideTextTimer = new Timer(0.6f); 
	m_overallTimer = new Timer(3.0f);

	/*m_loadItems.push_back((void*) loadItem1);
	m_loadItems.push_back((void*) loadItem2);
	m_loadItems.push_back((void*) loadItem3); 
	m_loadItems.push_back((void*) loadItem4);
	m_loadItems.push_back((void*) loadItem5);
	m_loadItems.push_back((void*) loadItem5_2); 
	m_loadItems.push_back((void*) loadItem6);
	m_loadItems.push_back((void*) loadItem7);
	m_loadItems.push_back((void*) loadItem8);
	m_loadItems.push_back((void*) loadItem9);*/
	m_loadItems.push_back((void*) loadItem1);
	m_loadItems.push_back((void*) loadItem2);
	m_loadItems.push_back((void*) loadItem3);
	m_loadItems.push_back((void*) loadItem10);

	m_itemsAt = 0;
	m_itemsMax = 3; 

	m_thread->init((void*) MyLoadingState::load);
}



void MyLoadingState::load() {
	//GameContainer* c = ARK2D::getContainer();
	//HWND wnd = c->m_hWindow;
	//c->enableOpenGL(wnd,
	//		&LMT::getInstance()->getLoadingState()->getThread()->m_deviceContext,
	//		&LMT::getInstance()->getLoadingState()->getThread()->m_renderingContext, false);
	DefaultGame* dg = DefaultGame::getInstance();

	//dg->stateLoading->m_showTextTimer->update();
	const float fps60 = 1.0f / 60.0f;
	dg->stateLoading->m_showTextTimer->setTime(dg->stateLoading->m_showTextTimer->getTime() + fps60);

	//ARK2D::getContainer()->getTimer()->sleep(10000);	

	//float startMillis = ARK2D::getContainer()->getTimer()->millis();
	
	ARK2D::getLog()->i("Start loading thread...");
	//GameContainer* container = ARK2D::getContainer();
	//std::cout << "start thread load()" << std::endl;
	dg->load();
	//ARK2D::getContainer()->getTimer()->sleep(3000);
	//std::cout << "done thread load()" << std::endl;
	ARK2D::getLog()->i("...Ending loading thread!");

	//float endMillis = ARK2D::getContainer()->getTimer()->millis();
	//dg->stateLoading->m_loadTime = (long) long(endMillis) - long(startMillis);

	dg->stateLoading->m_loading = false;
	dg->stateLoading->m_doneLoading = true;
	dg->stateLoading->m_hideTextTimer->setTime(0.005f);
	//lmt->getContainer()->getTimer()->flush();
	dg->stateLoading->m_thread->end();
}

void MyLoadingState::update(GameContainer* container, StateBasedGame* game, GameTimer* timer) {
	//std::cout << "start update!!!!!" << std::endl;

	const float fps60 = 1.0f / 60.0f; 
	if (m_firstFrame) {
		m_textState = TEXTSTATE_OUT;
	}

	if (m_loadItems.size() > 0) {
		void* fp = m_loadItems.at(0);
		void (*pt)() = (void(*)()) fp;
		pt();
		m_loadItems.erase(m_loadItems.begin()); 
	}
 
	if (!m_firstFrame) {
		//std::cout << "111111!!!!!" << std::endl;
		//m_lmt->backdrop->update(container, game, timer);
		//load();
		//m_animation->update(timer);

		if (m_showTextTimer->getTime() > 0.0f) {
			m_textState = TEXTSTATE_IN_TRANSITION;
			m_showTextTimer->setTime(m_showTextTimer->getTime() + fps60);
			//if (m_showTextTimer->update()) {
				m_showTextTimer->limit(1);
			//}
		} else {
			m_textState = TEXTSTATE_IN;
		}

		bool finishedOverall = false ; 
		//if (m_cubesInHit) {
			m_overallTimer->setTime(m_overallTimer->getTime() + fps60);
			finishedOverall = m_overallTimer->getTime() >= m_overallTimer->getDuration();

			if (!m_doneLoading && m_overallTimer->getTime() >= m_overallTimer->getDuration() - 1.0f) {
				m_overallTimer->setTime(m_overallTimer->getDuration() - 1.0f);
				finishedOverall = false;
			}
		//}

		if (!m_loading) 
		{
		//	std::cout << "222222!!!!!" << std::endl;
		//	wglMakeCurrent( *(m_lmt->getContainer()->getDeviceContext()), *(m_lmt->getContainer()->getRenderingContext()) );
		//	std::cout << "333333!!!!!" << std::endl;
			
			// temporary for quick loading/playing
			//#if !defined(ARK2D_ANDROID)  
			//	m_game->enterState(m_nextState);
			//	return;
			//#endif 
  
			ARK2D::getContainer()->getTimer()->flush();

			if (m_hideTextTimer->getTime() > 0.0f) {
				m_textState = TEXTSTATE_OUT_TRANSITION;
				m_hideTextTimer->setTime(m_hideTextTimer->getTime() + fps60);
				//if (m_hideTextTimer->update()) {
				if (m_hideTextTimer->getTime() > m_hideTextTimer->getDuration()) {
					m_hideTextTimer->limit(1);
					m_textState = TEXTSTATE_OUT;
				}
			}  

			 

		//	std::cout << "donedone!!!!!" << std::endl;
		} 

		 

		// we're done here. go in to the next game state.
		if (finishedOverall && m_textState == TEXTSTATE_OUT && m_doneLoading) {
			//m_overallTimer->reset(); // race condition android...

			//AnalyticsUtil::ga_sendTiming("load_time", m_loadTime, "start", "start");
 			//ARK2D::getContainer()->getTimer()->flush();
			//DefaultGame* dg = DefaultGame::getInstance(); 
			m_game->enterState(m_nextState, new FadeToColourTransition(0.5f, new Color(Color::darker_grey)), new FadeFromColourTransition(0.5f, new Color(Color::darker_grey)) );
			return;
		}

	} else {  

		


		
		//m_thread->join();
	} 
	//std::cout << "end update" << std::endl;
	m_firstFrame = false;
 
	float speed = float(m_itemsAt) / float(m_itemsMax);

} 


void MyLoadingState::render(GameContainer* container, StateBasedGame* game, Renderer* g) {
	
	g->setDrawColor(Color::white);

	g->drawString("LOADING...", 160, 380, Renderer::ALIGN_CENTER, Renderer::ALIGN_CENTER, 0.0f, 2.0f);

}


 
MyLoadingState::~MyLoadingState() {
	delete m_showTextTimer;
	delete m_hideTextTimer;
	delete m_overallTimer;
}

