/*
 * MyLoadingState.h
 *
 *  Created on: 29th Mar 2011
 *      Author: Ashley
 */

#ifndef MY_LOADING_STATE_H_
#define MY_LOADING_STATE_H_

#include "../ARK.h"

class DefaultGame;

class MyLoadingState : public LoadingState {
	public:
		MyLoadingState(DefaultGame* game);

		virtual void enter(GameContainer* container, StateBasedGame* game, GameState* from);
		virtual void leave(GameContainer* container, StateBasedGame* game, GameState* to);

		unsigned int id();

		void init(GameContainer* container, StateBasedGame* game);

		static void load();

		void update(GameContainer* container, StateBasedGame* game, GameTimer* timer);
		void render(GameContainer* container, StateBasedGame* game, Renderer* g);

		virtual ~MyLoadingState(); 

	public:
		DefaultGame* m_game;
		bool m_firstFrame;
		GameState* m_nextState;

		unsigned int m_textState;
		static const unsigned int TEXTSTATE_OUT = 0;
		static const unsigned int TEXTSTATE_IN_TRANSITION = 1;
		static const unsigned int TEXTSTATE_IN = 2;
		static const unsigned int TEXTSTATE_OUT_TRANSITION = 3;
		Timer* m_showTextTimer;
		Timer* m_hideTextTimer;

		Timer* m_overallTimer;
		bool m_doneLoading;
		

		unsigned int m_itemsAt;
		unsigned int m_itemsMax;


		vector<void*> m_loadItems;
};

#endif /* MY_LOADING_STATE_H_ */
